<HTML><HEAD><TITLE>6.828 / Fall 2011 / Schedule </TITLE><META HTTP-EQUIV="pragma" CONTENT="no-cache"><link rel="stylesheet" type="text/css" href="style.css"></HEAD><BODY BGCOLOR=#ffffff TEXT=#000000><TABLE cols="3" WIDTH="100%" height="100%" border="0" cellspacing="0" cellpadding="0"><tbody><tr height="40px"><td colspan=3><table width="100%" height="40px" border=0 cellspacing=0 cellpadding=0><tbody><tr><td bgcolor="#000000"><div align="left" style="padding-left:58px; padding-top: 2px;"><font style="font-size: 28px; color: #ffffff"><a name="top"><b>6.828</b>: Operating System Engineering </a></font></div></td><td bgcolor="#8a0a0a" halign="center" valign="center" width="250px"><div align="center" style="padding-top: 2px; padding-bottom: 4px;"><font style="font-size: 28px; color: #ffffff">Fall <b>2011</b> </font></div></td></tr></tbody></table></td></tr><tr><td colspan="3" height="5px" bgcolor="#8a0a0a"></td></tr><tr><td bgcolor="#8a0a0a" valign="top" width="180px"><table cols=2 rows=1 border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tbody><tr><td valign="top"><table cols=1 rows=1 border=0 cellspacing=0 cellpadding=0 width="100%"><tbody><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><A HREF="index.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">Home</A></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><A HREF="overview.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">Overview</A></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><A HREF="general.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">General Administrivia</A><BR></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><A HREF="schedule.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">Schedule</A><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a href="tools.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">Tools</a><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a href="xv6.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">xv6</a><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a href="reference.html" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">Reference Materials</a><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a href="classes.html" style="color: #ffffff; text-decoration: none;
font-weight: bold; font-size:16px">Related classes</a><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a href="../2010" style="color: #ffffff; text-decoration: none; font-weight: bold; font-size:16px">2010 Class Materials</a><br></div></td></tr><tr><td><div align="center" style="padding-top: 8px; padding-bottom: 8px;"><a rel="license" href="http://creativecommons.org/licenses/by/3.0/us/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by/3.0/us/88x31.png" /></a><br /></div></td></tr></tbody></table></td><td width="3px" bgcolor="#8a0a0a"></td></tr></tbody></table></td><td colspan="2"><table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr><td style="padding-left:10px; padding-right:10px; padding-top: 10px; padding-bottom: 10px" valign="top" align="left"><style>
table.calendar {
    font-family: arial, helvetica;
    font-size: 10pt;
    empty-cells: show;
    border: 1px solid #000000;
    border-collapse: collapse;
}
table.calendar tr td {
    border: 1px solid #aaaaaa;
}
table.calendar tr {
    vertical-align: top;
    height: 6em;
    background: #eeeeee;
}
table.calendar thead tr {
    text-align: center;
    background: #444444;
    color: #ffffff;
    height: auto;
    font-weight: bold;
}
.lecture {
    background: #ffffaa;
}
.holiday {
    background: #ccffcc;
}
.special {
    background: #aaaaff;
}
.important {
    background: #ffaaaa;
}
.reading {
    color: #3333ff;
}
.deadline {
    color: #ff0000;
}
.assignment {
    color: #0aa00a;
}
.date {
    color: #444444;
}
</style> Links to notes etc. on future days are copies of materials from 2010 to give you an idea what the future will bring. We will update the notes as the course progresses.<p><table class="calendar" cellspacing="0" cellpadding="6" width="100%"><thead><tr><td width="35%">Monday</td><td width="10%">Tuesday</td><td width="35%">Wednesday</td><td width="10%">Thursday</td><td width="10%">Friday</td></tr></thead><tr><td id="2011-9-5" class="holiday"><span class="date">sep 5</span></td><td id="2011-9-6" class="special"><span class="date">sep 6</span><br />Reg Day</td><td id="2011-9-7" class="lecture"><span class="date">sep 7</span><br /><b>LEC 1:</b> <a href="lec/l-overview.html">Operating systems</a> (handouts: <a href="xv6/xv6-rev6.pdf">xv6 source</a>, <a href="xv6/book-rev6.pdf">xv6 book</a>)<br /><span class="reading"><b>Preparation</b>: Read <a href="readings/ritchie79evolution.html">The Evolution of the Unix Time-Sharing System</a></span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab1/">Lab 1: C, Assembly, Tools, and Bootstrapping</a></span><br /><b>Videos:</b> <a href="vids/lec1_9_7_operating_systems/100_9135.MOV">1</a> <a href="vids/lec1_9_7_operating_systems/100_9136.MOV">2</a> <a href="vids/lec1_9_7_operating_systems/100_9137.MOV">3</a> <a href="vids/lec1_9_7_operating_systems/100_9138.MOV">4</a> <a href="vids/lec1_9_7_operating_systems/100_9139.MOV">5</a></td><td id="2011-9-8"><span class="date">sep 8</span></td><td id="2011-9-9"><span class="date">sep 9</span></td></tr><tr><td id="2011-9-12" class="lecture"><span class="date">sep 12</span><br /><b>LEC 2:</b> <a href="lec/l-x86.pdf">PC hardware and x86 programming</a><br /><span class="reading"><b>Preparation</b>: Read <a href="xv6/book-rev6.pdf">Bootstrap/PC hardware appendices and the related xv6 source files</a>; do <a href="homework/x86-intro.html">Homework 1</a></span><br /><b>Videos:</b> <a href="vids/lec2_9_12_pc_hw_x86/100_9161.MOV">1</a> <a href="vids/lec2_9_12_pc_hw_x86/100_9163.MOV">2</a></td><td id="2011-9-13"><span class="date">sep 13</span></td><td id="2011-9-14" class="lecture"><span class="date">sep 14</span><br /><b>LEC 3:</b> <a href="lec/l-xv6vm.txt">Virtual Memory</a> (handout: <a href="lec/x86_translation_and_registers.pdf">page table translation and registers</a>)<br /><span class="reading"><b>Preparation</b>: Read <a href="xv6/book-rev6.pdf">"The first process" up to "Exec" and the related xv6 source files</a>; do <a href="homework/xv6-intro.html">Homework 2</a></span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab2/">Lab 2: Memory management</a></span><br /><b>Videos:</b> <a href="vids/lec3_9_14_virtual_memory/100_9180.MOV">1</a> <a href="vids/lec3_9_14_virtual_memory/100_9181.MOV">2</a></td><td id="2011-9-15" class="important"><span class="date">sep 15</span><br /><span class="deadline"><b>DUE</b>: Lab 1</span></td><td id="2011-9-16"><span class="date">sep 16</span></td></tr><tr><td id="2011-9-19" class="lecture"><span class="date">sep 19</span><br /><b>LEC 4:</b> <a href="lec/l-josmem.html">JOS memory layout</a> (handouts: <a href="lec/jos_layout.pdf">JOS memory layout</a>)<br /><span class="reading"><b>Preparation</b>: Finish reading <a href="xv6/book-rev6.pdf">"The first process"</a>; do <a href="homework/x86-mmu.html">Homework 3</a></span><br /><b>Videos:</b> <a href="vids/lec4_9_19_jos_memory_layout/100_9224.MOV">1</a> <a href="vids/lec4_9_19_jos_memory_layout/100_9225.MOV">2</a></td><td id="2011-9-20"><span class="date">sep 20</span></td><td id="2011-9-21" class="holiday"><span class="date">sep 21</span><br />Student holiday</td><td id="2011-9-22"><span class="date">sep 22</span></td><td id="2011-9-23"><span class="date">sep 23</span></td></tr><tr><td id="2011-9-26" class="lecture"><span class="date">sep 26</span><br /><b>LEC 5:</b> <a href="lec/l-processes.txt">Process Creation</a> <a href="lec/l-interrupt.html">System call, Interrupt, and Exception Handling</a> (handouts: <a href="lec/x86_idt.pdf">IDT</a>)<br /><span class="reading"><b>Preparation</b>: Read <a href="xv6/book-rev6.pdf">"Traps, interrupts, and drivers" and the related xv6 source files</a>; do <a href="homework/x86-intr.html">Homework 4</a></span><br /><b>Videos:</b> <a href="vids/lec5_9_26_proccreate_intrp_excep/100_9397.MOV">1</a> <a href="vids/lec5_9_26_proccreate_intrp_excep/100_9398.MOV">2</a> <a href="vids/lec5_9_26_proccreate_intrp_excep/100_9399.MOV">3</a> <a href="vids/lec5_9_26_proccreate_intrp_excep/100_9400.MOV">4</a></td><td id="2011-9-27"><span class="date">sep 27</span></td><td id="2011-9-28" class="lecture"><span class="date">sep 28</span><br /><b>LEC 6:</b> <a href="lec/l-lockv1.txt">Virtual Memory Multiprocessors and locking</a><br /><span class="reading"><b>Preparation</b>: Read <a href="xv6/book-rev6.pdf">"Locking"</a> with spinlock.c and skim mp.c; do <a href="homework/xv6-lock.html">Homework 5</a></span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab3/">Lab 3: User-Level Environments</a></span></td><td id="2011-9-29" class="important"><span class="date">sep 29</span><br /><span class="deadline"><b>DUE</b>: Lab 2</span></td><td id="2011-9-30"><span class="date">sep 30</span></td></tr><tr><td id="2011-10-3" class="lecture"><span class="date">oct 3</span><br /><b>LEC 7:</b> <a href="lec/l-threadsv1.txt">Process scheduling</a><br /><span class="reading"><b>Preparation</b>: Read <a href="xv6/book-rev6.pdf">"Scheduling"</a> up to "Sleep and wakeup" with proc.c, setjmp.S, and sys_fork (in sysproc.c); do <a href="homework/xv6-sched.html">Homework 6</a></span><br /><b>Videos:</b> <a href="vids/lec7_10_3_scheduling/100_9426.MOV">1</a> <a href="vids/lec7_10_3_scheduling/100_9427.MOV">2</a></td><td id="2011-10-4"><span class="date">oct 4</span></td><td id="2011-10-5" class="lecture"><span class="date">oct 5</span><br /><b>LEC 8:</b> <a href="lec/l-coordination.html">Processes and coordination</a><br /><span class="reading"><b>Preparation</b>: Read remainder of <a href="xv6/book-rev6.pdf">"Scheduling"</a>; read remainder of proc.c and sys_wait, sys_exit, sys_kill; do <a href="homework/xv6-sleep.html">Homework 7</a></span><br /><b>Videos:</b> <a href="vids/lec8_10_5_processes/100_9433.MOV">1</a> <a href="vids/lec8_10_5_processes/100_9434.MOV">2</a> <a href="vids/lec8_10_5_processes/100_9435.MOV">3</a> <a href="vids/lec8_10_5_processes/100_9436.MOV">4</a> <a href="vids/lec8_10_5_processes/100_9437.MOV">5</a></td><td id="2011-10-6" class="important"><span class="date">oct 6</span><br /><span class="deadline"><b>DUE</b>: Lab 3 (Part A)</span></td><td id="2011-10-7" class="special"><span class="date">oct 7</span><br />ADD DATE</td></tr><tr><td id="2011-10-10" class="holiday" colspan="2"><span class="date">oct 10 - oct 11</span><br />Columbus Day</td><td id="2011-10-12" class="lecture"><span class="date">oct 12</span><br /><b>LEC 9:</b> <a href="lec/l-fs.txt">File systems</a><br /><span class="reading"><b>Preparation</b>: Read bio.c, fs.c, sysfile.c, file.c and "File system" except for the logging sections; do <a href="homework/xv6-disk.html">Homework 8</a></span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab4/">Lab 4: Preemptive Multitasking</a></span><br /><b>Videos:</b> <a href="vids/lec9_10_12_file_systems/100_9471.MOV">1</a> <a href="vids/lec9_10_12_file_systems/100_9472.MOV">2</a></td><td id="2011-10-13" class="important"><span class="date">oct 13</span><br /><span class="deadline"><b>DUE</b>: Lab 3 (Part B)</span></td><td id="2011-10-14"><span class="date">oct 14</span></td></tr><tr><td id="2011-10-17" class="lecture"><span class="date">oct 17</span><br /><b>LEC 10:</b> <a href="lec/l-crash.txt">Crash recovery</a><br /><span class="reading"><b>Preparation</b>: Read log.c and the logging sections of "File system"; do <a href="homework/xv6-log.html">Homework 9</a></span><br /><b>Videos:</b> <a href="vids/lec10_10_17_fs_crash_recovery/100_9493.MOV">1</a> <a href="vids/lec10_10_17_fs_crash_recovery/100_9494.MOV">2</a></td><td id="2011-10-18"><span class="date">oct 18</span></td><td id="2011-10-19" class="important"><span class="date">oct 19</span><br /><b class="deadline">QUIZ #1</b>: Mid-term quiz during lecture time<br /><b>open book and notes</b><br /><b>scope</b>: Lectures 1-10, xv6, and labs<br /><b>practice:</b> <a href="/6.828/quiz/">previous years' quizzes</a>.</td><td id="2011-10-20" class="important"><span class="date">oct 20</span><br /><span class="deadline"><b>DUE</b>: Lab 4 (Part A)</span></td><td id="2011-10-21"><span class="date">oct 21</span></td></tr><tr><td id="2011-10-24" class="holiday"><span class="date">oct 24</span><br />Hacking day</td><td id="2011-10-25"><span class="date">oct 25</span></td><td id="2011-10-26" class="holiday"><span class="date">oct 26</span><br />Hacking day</td><td id="2011-10-27" class="important"><span class="date">oct 27</span><br /><span class="deadline"><b>DUE</b>: Lab 4 (Part B)</span></td><td id="2011-10-28"><span class="date">oct 28</span></td></tr><tr><td id="2011-10-31" class="lecture"><span class="date">oct 31</span><br /><b>LEC 11:</b> <a href="lec/l-journal.txt">File system performance and fast crash recovery</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/journal-design.pdf">Journaling the Linux ext2fs Filesystem</a>; do <a href="homework/journal-ext2fs.html">Homework 10</a></span><br /><b>Videos:</b> <a href="vids/lec11_10_31_fs_performance_crashrec2/100_9610.MOV">1</a> <a href="vids/lec11_10_31_fs_performance_crashrec2/100_9611.MOV">2</a></td><td id="2011-11-1"><span class="date">nov 1</span></td><td id="2011-11-2" class="lecture"><span class="date">nov 2</span><br /><b>LEC 12:</b> <a href="lec/l-sync.txt">Performance and durability</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/rethink-the-sync.pdf">Rethink the sync</a>; no homework</span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab5/">Lab 5: File system and Spawn</a></span><br /><b>Videos:</b> <a href="vids/lec12_11_2_performance_durability/100_9612.MOV">1</a></td><td id="2011-11-3" class="important"><span class="date">nov 3</span><br /><span class="deadline"><b>DUE</b>: Lab 4 (Part C)</span></td><td id="2011-11-4"><span class="date">nov 4</span></td></tr><tr><td id="2011-11-7" class="lecture"><span class="date">nov 7</span><br /><b>LEC 13:</b> <a href="lec/l-schedule.txt">Scheduling</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/mogul96usenix.pdf">Eliminating Receive Livelock</a>; do <a href="homework/livelock.html">Homework 12</a></span><br /><b>Videos:</b> <a href="vids/lec13_11_7_scheduling/100_9628.MOV">1</a> <a href="vids/lec13_11_7_scheduling/100_9629.MOV">2</a></td><td id="2011-11-8"><span class="date">nov 8</span></td><td id="2011-11-9" class="lecture"><span class="date">nov 9</span><br /><b>LEC 14:</b> <a href="lec/l-organization.txt">OS Organization</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/engler95exokernel.pdf">Exokernel</a>; do <a href="homework/exok.html">Homework 13</a></span><br /><b>Videos:</b> <a href="vids/lec14_11_9_os_organization/100_9630.MOV">1</a></td><td id="2011-11-10"><span class="date">nov 10</span></td><td id="2011-11-11" class="holiday"><span class="date">nov 11</span><br />Veteran's Day</td></tr><tr><td id="2011-11-14" class="lecture"><span class="date">nov 14</span><br /><b>LEC 15:</b> <a href="lec/l-singularity.html">Language/OS co-design</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/hunt07singularity.pdf">Singularity</a>; no homework</span><br /><b>Videos:</b> <a href="vids/lec15_11_14_language_os_codesign/100_9819.MOV">1</a> <a href="vids/lec15_11_14_language_os_codesign/100_9820.MOV">2</a> <a href="vids/lec15_11_14_language_os_codesign/100_9821.MOV">3</a> <a href="vids/lec15_11_14_language_os_codesign/100_9822.MOV">4</a></td><td id="2011-11-15"><span class="date">nov 15</span></td><td id="2011-11-16" class="lecture"><span class="date">nov 16</span><br /><b>LEC 16:</b> <a href="lec/l-scalable-lock.txt">Scalable locks</a> (<a href="lec/scalable-lock-code.c">code</a>)<br /><span class="reading"><b>Preparation</b>: Read unpublished document; do <a href="homework/ticketlock.html">Homework 15</a></span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab6/">Lab 6: Network Driver</a></span><br /><b>Videos:</b> <a href="vids/lec16_11_16_scalable_locks/100_9823.MOV">1</a> <a href="vids/lec16_11_16_scalable_locks/100_9824.MOV">2</a></td><td id="2011-11-17" class="important"><span class="date">nov 17</span><br /><span class="deadline"><b>DUE</b>: Lab 5</span></td><td id="2011-11-18"><span class="date">nov 18</span><br /><span class="assignment"><b>Assignment</b>: <a href="labs/lab7/">Lab 7: Final Project</a></span></td></tr><tr><td id="2011-11-21" class="lecture"><span class="date">nov 21</span><br /><b>LEC 17:</b> <a href="lec/l-lockfree.txt">Lock-free coordination</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/scale.pdf">Linux Scalability</a>; do <a href="homework/linuxscale.html">Homework 16</a></span><br /><b>Videos:</b> <a href="vids/lec17_11_21_lockfree_coordination/100_9828.MOV">1</a> <a href="vids/lec17_11_21_lockfree_coordination/100_9829.MOV">2</a></td><td id="2011-11-22"><span class="date">nov 22</span></td><td id="2011-11-23" class="important"><span class="date">nov 23</span><br /><b class="deadline">DROP DATE</b><br /><b>LEC 18:</b> <a href="lec/l-race.txt">Race Detection</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/Erickson.pdf">DataCollider</a></span><br /><span class="deadline"><b>DUE</b>: Lab 6 (Part A)</span><br /><b>Videos:</b> <a href="vids/lec18_11_23_race_detection/100_9833.MOV">1</a> <a href="vids/lec18_11_23_race_detection/100_9834.MOV">2</a></td><td id="2011-11-24" class="holiday" colspan="2"><span class="date">nov 24 - nov 25</span><br />Thanksgiving</td></tr><tr><td id="2011-11-28" class="lecture"><span class="date">nov 28</span><br /><b>LEC 19:</b> <a href="lec/l-vm.txt">Virtual Machines</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/adams06vmware.pdf">Software vs Hardware Virtualization</a>; do <a href="homework/vm.html">Homework 18</a></span><br /><b>Videos:</b> <a href="vids/lec19_11_28_virtual_machines/100_9869.MOV">1</a> <a href="vids/lec19_11_28_virtual_machines/100_9870.MOV">2</a></td><td id="2011-11-29"><span class="date">nov 29</span></td><td id="2011-11-30" class="lecture"><span class="date">nov 30</span><br /><b>LEC 20:</b> <a href="lec/l20.txt">Virtual Machine Applications</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/esx-mem-osdi02.pdf">ESX Memory</a>; do <a href="homework/proposal.html">Homework: final project proposal</a></span><br /><b>Videos:</b> <a href="vids/lec20_11_30_virtual_machine_applications/100_9874.MOV">1</a> <a href="vids/lec20_11_30_virtual_machine_applications/100_9875.MOV">2</a></td><td id="2011-12-1" class="important"><span class="date">dec 1</span><br /><span class="deadline"><b>DUE</b>: Lab 6 (Part B)</span></td><td id="2011-12-2"><span class="date">dec 2</span></td></tr><tr><td id="2011-12-5" class="lecture"><span class="date">dec 5</span><br /><b>LEC 21:</b> <a href="lec/l21.txt">Bugs</a><br /><span class="reading"><b>Preparation</b>: Read <a href="readings/klee.pdf">Klee</a>; do <a href="homework/klee.html">Homework 20</a></span><br /><b>Videos:</b> <a href="vids/lec21_12_5__bugs/100_9891.MOV">1</a> <a href="vids/lec21_12_5__bugs/100_9892.MOV">2</a></td><td id="2011-12-6"><span class="date">dec 6</span></td><td id="2011-12-7" class="lecture"><span class="date">dec 7</span><br /><b>LEC 22:</b> Rebootless updates<br /><span class="reading"><b>Preparation</b>: Read <a href="readings/ksplice.pdf">Ksplice</a></span><br /><b>Videos:</b> <a href="vids/lec22_12_7_ksplice/100_9897.MOV">1</a> <a href="vids/lec22_12_7_ksplice/100_9898.MOV">2</a></td><td id="2011-12-8"><span class="date">dec 8</span></td><td id="2011-12-9" class="important"><span class="date">dec 9</span><br /><span class="deadline"><b>DUE</b>: Lab 7</span></td></tr><tr><td id="2011-12-12" class="lecture"><span class="date">dec 12</span><br /><b>LEC 23:</b> <b><span class="deadline">OS Bakeoff</span></b></td><td id="2011-12-13"><span class="date">dec 13</span></td><td id="2011-12-14" class="holiday"><span class="date">dec 14</span><br />No lecture (TA check-offs)</td><td id="2011-12-15"><span class="date">dec 15</span></td><td id="2011-12-16"><span class="date">dec 16</span></td></tr><tr><td id="2011-12-19" class="important"><span class="date">dec 19</span><br /><b class="deadline">QUIZ #2</b>: 1:30pm&ndash;4:30pm in du Pont<br /><b>open book and notes</b><br /><b>scope</b>: Lectures 11-22, labs 4-7<br /><b>practice:</b> <a href="/6.828/quiz/">previous years' quizzes</a>.</td><td id="2011-12-20"><span class="date">dec 20</span></td><td id="2011-12-21"><span class="date">dec 21</span></td><td id="2011-12-22"><span class="date">dec 22</span></td><td id="2011-12-23"><span class="date">dec 23</span></td></tr></table><script type="text/javascript">var d = new Date();
for (var fwd = 0; fwd < 3; fwd++) {
  var i = d.getFullYear()+'-'+(d.getMonth()+1)+'-'+d.getDate();
  var e = document.getElementById(i);
  if (e) { e.style.border = '2px solid blue'; break; }
  d.setTime(d.getTime() + 24*60*60*1000);
}
</script> <!--//--></td></tr><tr bgcolor="#999999" height="20px"><td style="padding-left:10px; padding-top: 10px; padding-bottom: 10px"><font style="font-size: 12px;"><p>Questions or comments regarding 6.828? Send e-mail to the TAs at <A HREF="mailto:6.828-staff@pdos.csail.mit.edu"><I>6.828-staff@pdos.csail.mit.edu</I></A>.<p><B><A HREF="#top">Top</A></B> // <B><A HREF="index.html">6.828 home</A></B> // <i>Last updated Sunday, 18-Dec-2011 20:59:06 EST</i> </font></td></tr></table></td></tr></tbody></table></BODY></HTML>